package org.nuts4cocos.emptyenter;

import android.app.Activity;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.inputmethod.EditorInfo;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;

public class EmptyEnter extends Activity {
  boolean lastCharWasEnter;
  TextView.OnEditorActionListener listener;
  EditText editText;
  EditText enterType;
  String enter;
  int cursor;
  boolean touched;
  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.main);
    cursor=0;
    touched=false;
    lastCharWasEnter=false;
    enter="<enter>\n";
		editText=(EditText)findViewById(R.id.editText);
    enterType=(EditText)findViewById(R.id.enterType);
    
		editText.setOnEditorActionListener(new TextView.OnEditorActionListener() {
			@Override
			public boolean onEditorAction
      (TextView view, int actionId, KeyEvent event) {
        if (event==null) {
          if (actionId==EditorInfo.IME_ACTION_DONE);
          else if (actionId==EditorInfo.IME_ACTION_NEXT);
          else return false;
        }
        else if (actionId==EditorInfo.IME_NULL) {
          if (event.getAction()==KeyEvent.ACTION_DOWN); 
          else  return true;
        }
        else  return false; 
        
        if (lastCharWasEnter) {;
          editText.getText().replace(cursor-1, cursor, "");
          enterType.setText("Empty-Enter"); // do shift-enter stuff here
          lastCharWasEnter=false;
          return true;
				}
        enterType.setText("Enter");
        return false;
			}
		});
    
    editText.setOnTouchListener(new View.OnTouchListener() {
      @Override
      public boolean onTouch(View view, MotionEvent event) {
        lastCharWasEnter=false;
        touched=true;
        return false;
      }
    });
    
    enterType.setOnTouchListener(new View.OnTouchListener() {
      @Override
      public boolean onTouch(View view, MotionEvent event) {
        return true;
      }
    });
    
		editText.addTextChangedListener(new TextWatcher() {
			public void beforeTextChanged
			(CharSequence s, int start, int count, int after) {
			}
			public void onTextChanged
			(CharSequence s, int start, int before, int count) {
        if ((start==cursor || touched) && before==0 && count==1
        && s.charAt(start)=='\n') lastCharWasEnter=true;
        else {
          lastCharWasEnter=false;
          enterType.setText("");
        }
        touched=false;
        cursor=start+count;
      }
			public void afterTextChanged(Editable s) {
    	}
		});
    
  }
}